мир.платформы = {
    умолчание: {
        x: 100,
        y: 100,
        ширина: 40,
        высота: 20,
        цвет: "#ffffff",
        статика: true,
    },
    задано: {},
    тела: {},
    элементы: {},
    свойстваТела: ["x", "y", "ширина", "высота", "статика"],
    обновить: обновитьПлатформы,
};


// // // //


мир.ключники.push(function(ключ, путь, значение){
    if (!ключ.startsWith("платформы"))
    {
        return;
    }

    var имя = путь[1];
    var свойство = путь[2];

    сохранитьЗаданноеЗначение(имя, свойство, значение);
    пересоздатьТело(имя, свойство, значение);
    обновитьЭлемент(имя, свойство, значение);
});


// // // //


function обновитьПлатформы()
{
    for (var имя in мир.платформы.тела)
    {
        var тело = мир.платформы.тела[имя];
        if (тело.isSleeping)
        {
            continue;
        }
        var элемент = мир.платформы.элементы[имя];
        let x = тело.position.x - элемент.offsetWidth / 2;
        let y = тело.position.y - элемент.offsetHeight / 2;
        let угол = тело.angle;
        элемент.style.transform = `translate(${x}px, ${y}px) rotate(${угол}rad)`;
    }
}

function сохранитьЗаданноеЗначение(имя, свойство, значение)
{
    if (!(имя in мир.платформы.задано))
    {
        мир.платформы.задано[имя] = {};
    }
    мир.платформы.задано[имя][свойство] = значение;
}

function пересоздатьТело(имя, свойство, значение)
{
    if (!мир.платформы.свойстваТела.includes(свойство))
    {
        return;
    }

    // Удалить физическое тело.
    if (имя in мир.платформы.тела)
    {
        var тело = мир.платформы.тела[имя];
        Matter.Composite.remove(мир.физика.движок.world, тело);
    }
    // Пересоздать физическое тело.
    var за = мир.платформы.задано[имя];
    var ум = мир.платформы.умолчание;

    var x = за["x"] ? за["x"] : ум["x"];
    var y = за["y"] ? за["y"] : ум["y"];
    var ширина = за["ширина"] ? за["ширина"] : ум["ширина"];
    var высота = за["высота"] ? за["высота"] : ум["высота"];
    var свойства = {
        isStatic: ("статика" in за) ? за.статика : ум.статика,
    };

    var тело = Matter.Bodies.rectangle(x, y, ширина, высота, свойства);
    Matter.Composite.add(мир.физика.движок.world, тело);
    мир.платформы.тела[имя] = тело;
}

function обновитьЭлемент(имя, свойство, значение)
{
    if (!(имя in мир.платформы.элементы))
    {
        var элемент = document.createElement("div");
        элемент.style.position = "absolute";
        элемент.style.display = "block";
        элемент.style.transformOrigin = "center";
        document.body.appendChild(элемент);
        мир.платформы.элементы[имя] = элемент;
    }

    var элемент = мир.платформы.элементы[имя];
    var за = мир.платформы.задано[имя];
    var ум = мир.платформы.умолчание;

    if (свойство == "ширина")
    {
        var ширина = за["ширина"] ? за["ширина"] : ум["ширина"];
        элемент.style.width = `${ширина}px`;
    }
    else if (свойство == "высота")
    {
        var высота = за["высота"] ? за["высота"] : ум["высота"];
        элемент.style.height = `${высота}px`;
    }
    else if (свойство == "цвет")
    {
        элемент.style.backgroundColor = за["цвет"];
    }
}
